@device(postscript)

@center<Tektronix 4010/4014 Graphics Terminal Functions>

@begin<table>
@bar()
@blankspace(1)
@begin<format>
@tabclear()
@case[device,file="@tabset(1.6inch,3.0inch,3.75inch)",
        else="@tabset(1.5inch,3.0inch,3.75inch)"
]
@ux<Control Code>@\@\@ux<Action>
@q<FS, > Control-@q<\>@\Backslash@\draw dots
@q<GS, > Control-@q<]>@\Right square bracket@\draw lines
@q<RS, > Control-@q<^>@\Caret@\Draw dots incrementally
@q<US, > Control-@q<_>@\Underscore@\Display text
@q<BEL,> Control-@q<G>@\@\Beep, make a noise
@q<BS, > Control-@q<H>@\@\Backspace, non-destructive
@q<HT, > Control-@q<I>@\@\Tab, convert to single space
@q<LF, > Control-@q<J>@\@\Line feed, go down one line
@q<VT, > Control-@q<K>@\@\Move up one text line
@q<FF, > Control-@q<L>@\@\Clears the screen
@q<CR, > Control-@q<M>@\@\Carriage return, start of line
@q<CAN,> Control-@q<X>@\@\Exit Tek sub-mode, or ignore
DEL, RUBOUT@\@\Delete code, same as BS

@ux<Escape Sequence>@\@\@ux<Action>
@q<ESC >Control-@q<E>@\@\Send a status report, turn on Bypass mode
@q<ESC >Control-@q<L>@\@\Clear the screen (enter sub-mode from VT102)
@q<ESC >Control-@q<X>@\@\Turn on Bypass mode
@q<ESC >Control-@q<Z>@\@\Activate crosshairs (GIN mode) and Bypass mode
@q<ESC Z>@\@\Send terminal identification
@q<ESC `> (accent grave)@\@\Use solid lines in drawing
@q<ESC a> through @q<ESC e>@\@\Use dashed line patterns:
@\@\@ a=fine dots, b=short dashes
@\@\@ c=dash dot,  d=long dash dot
@\@\@ e=dash dot dot.
@q<ESC [ Pn ; Pn m>@\@\Set ANSI colors. Same as for VT102.
@q<ESC [ ? 3 8 l>@\@\Exit Tek mode (become text terminal, VT102 etc)
@q<ESC [ ? 3 8 h>@\@\Enter Tek mode (from VT102 mode)
@end<format>
@caption<Response of Tektronix Emulator to Received Characters>
@bar()
@end(table)

In the table, US is the name for the ASCII character Control-Underscore, 31
decimal.  Text is written starting with the last drawn point being the lower
left corner of the first 8 by 8 character cell.  The drawing position is
updated by 8 dots to the right for each character, and lines wrap at column 80
(column 90 for Hercules boards).  If text extends "below the screen" the sign
"@q(More >)" is shown at the bottom right corner and the user needs to press a
key to continue.  Then the screen will be cleared and the new text will start
at the top of the screen (no scrolling is done in graphics mode).  A real Tek
4010 begins new text at column 40 and will overwrite dots from older material.
Text mode is interrupted by the drawing commands discussed
below.

@subu<Bypass Mode>:

Certain Tektronix commands turn on or off "Bypass" mode whereby incoming
text is not displayed on the screen. Removal of echos of the GIN mode,
discussed below, is the major use of Bypass. Bypass mode is turned on by
receipt of
        ESC Control-E, ESC Control-X, and ESC Control-Z
and it is turned off upon receipt of
        BEL, LF, CR, US, other escape sequences, and resetting the terminal.

@subu<Drawing commands GS, FS, RS>:

1. Draw a line or move to a point: GS <@i(xy) @i(xy) @value<ellips> @i(xy)>

GS is the name for ASCII character Control-@q<]> (right square bracket),
decimal 29.  <@i(xy)> stands for an encoded x,y coordinate as explained below.
One or more x,y coordinates may follow GS and line segments are drawn from
point to point.  The first point is reached without drawing so that GS and the
initial <@i(xy)> is a simple "move-to" command rather than a "draw-to" command.XLines may be constructed from six dash patterns described in Table
@ref(-mstekrc).  <@i(xy)> coordinates are encoded by separating the 10 bit
value of x and of y into 5 bit components and then adding two high bits to eachXto identify which component is being represented: high-y, low-y, high-x, or
low-x. They are transmitted in that order, with the low-x byte always sent
last.  In fact, bytes may be omitted if they do not change from point to point,Xprovided that low-x is always sent.  These bytes range from ASCII space (32
decimal) to ASCII DEL (127 decimal).  Details are given below, and summarized
in Table @ref(-mstekxy).  This mode completes when a new command or a CR LF
(carriage return, line feed) arrives; escape sequences are processed
transparently but other control codes are ignored.  The interrupting character
is accepted and processed next.

2. Draw dots at given locations: FS <@i(xy) @i(xy) @value<ellips> @i(xy)>

FS is the name for the ASCII character Control-\ (backslash), decimal 28.
<@i(xy)> is in the same form as above.  A dot is drawn at each x,y point.  ThisXmode completes when a new command or a CRLF character arrives; escape sequencesXare processed transparently but other control codes are ignored.  The
interrupting character is accepted and processed next.

3. Draw dots from the current location: RS @i(<pen> <direction> <direction>
@value<ellips> <direction>)

RS is the name for the ASCII character Control-@q(^) (caret), decimal 30.
@i<pen> is the character Space (32 decimal) to move without drawing or P (80
decimal) to draw while moving.  @i(<direction>) is one of the letters A, E, D,
F, B, J, H, I as shown in Table @ref<-mstekdd>.

@begin<table>
@bar()
@blankspace(1)
@begin<format>
@tabclear()@tabset(0.5inch,1.25inch,3.50inch)
@ux(@i[<direction>])@\@ux<Move One Tek Dot This Way>
@\A@\East (right)
@\E@\East and North@\@q< F   D   E>
@\D@\North (up)
@\F@\North and West@\@q< B   *   A>     (@q<*> is current location)
@\B@\West
@\J@\South and West@\@q< J   H   I>
@\H@\South
@\I@\South and East
@end<format>
@caption<Tektronix Dot-Drawing Commands>
@bar()
@end(table)

Example: @q<RS P J J J> (no spaces here, naturally) means draw three dots in
the southwest direction, stepping to each in turn.  This mode completes when a
new command or a non-@i(<pen>) or non-@i(<direction>) character arrives; the
interrupting character is accepted and processed next.

@subu[Graphics INput (GIN) mode]:

Graphics input mode is entered when ESC Control-Z is received.  A crosshair is
drawn on the screen and may be moved by the numeric keypad arrows (fine scale
motion) or the Shift key and these arrows (coarse scale motion).  Pressing an
ASCII-producing key sends the position of the crosshairs to the host as the
sequence of: pressed key, X coordinate, Y coordinate, carriage return, then
removes the crosshairs, and then returns to text mode.  The coordinates are
encoded by splitting them into five bit fields, adding an ascii space (20H)
to each, and are sent as high-y, low-y, high-x and low-x bytes. Bypass mode
is active while the report is sent to supress echos of the report.
One may prematurely exit GIN mode by typing Control-C or Control-Break.
Shift-PrtSc (DOS screen dump) remains active, however.

@subu(Status or Position Report):

ESCAPE Control-E requests a status report from the emulator.  Tek terminals
have many sub-fields.  Kermit-MS sends a byte of 24 hex for being in text mode
or 20 hex otherwise, followed by the encoded X then Y coordinates and a
carriage return.  Coordinates are encoded 5 bits at a time similar to the GIN
report.

@subu(Identification Report):

ESCAPE Z requests terminal identification, as for VT52 and VT102.  Currently
this report is the 10 character sequence @w(@q<IBM_TEK ESCAPE / Z>) (no
spaces).

@subu(Coordinate Encoding):

Coordinate 0,0 is the lower left corner and the X axis is horizontal. TektronixXpositions are mapped into the typically 640 dots wide by 200 or 350 dots high
PC screen and thus adjacent Tek positions may yield the same PC screen dot.

4010-like devices use positions from 0 to 1023 for both X and Y, although only
0 to 779 are visible for Y due to screen geometry.  The Tek screen is 10.24 by
7.80 inches and coordinates are sent as 1-4 characters.

4014-like devices use positions 0 to 4095, but each movement is a multiple of 4Xpositions unless the high-resolution LSBXY are sent.  This makes it compatible
with the 4010 in that a full sized plot fills the screen.  The emulator acceptsXthe LSBXY components but does not use them.

The various modes are summarized in Table @ref<-mstekxy>, in which the
following notation is used:
@begin(display)
HIX, HIY = High order 5 bits of a 10 or 12 bit position.
LOX, LOY = Middle order 5 bits of position (low order of Tek 4010).
LSBXY = Low order 2 bits of X + low order 2 bits of Y (4014 mode),
   recognized by the Tek emulator but not used to calculate position.
@end(display)

@begin<table>
@bar()
@blankspace(1)
@begin<format>
@tabclear()
@tabset(0.75inch,1.5inch,2.25inch,3.0inch,3.6inch,4.1inch,4.7inch,
        5.3inch,5.95inch)
@ux<Hi Y>@\@ux<Lo Y>@\@ux<Hi X>@\@ux<LSBXY>@\@ux<Characters Sent @~
(Lo-X Always Sent)>
Same@\Same@\Same@\Same@\@\@\@\@\Lo-X
Same@\Same@\Same@\Diff@\@\LSB,@\Lo-Y,@\@\Lo-X@\4014
Same@\Same@\Diff@\Same@\@\@\Lo-Y,@\Hi-X,@\Lo-X
Same@\Same@\Diff@\Diff@\@\LSB,@\Lo-Y,@\Hi-X,@\Lo-X@\4014
Same@\Diff@\Same@\Same@\@\@\Lo-Y,@\@\Lo-X
Same@\Diff@\Same@\Diff@\@\LSB,@\Lo-Y,@\@\Lo-X@\4014
Same@\Diff@\Diff@\Same@\@\@\Lo-Y,@\Hi-X,@\Lo-X
Same@\Diff@\Diff@\Diff@\@\LSB,@\Lo-Y,@\Hi-X,@\Lo-X@\4014
Diff@\Same@\Same@\Same@\Hi-Y,@\@\@\@\Lo-X
Diff@\Same@\Same@\Diff@\Hi-Y,@\LSB,@\Lo-Y,@\@\Lo-X@\4014
Diff@\Same@\Diff@\Same@\Hi-Y,@\@\Lo-Y,@\Hi-X,@\Lo-X
Diff@\Same@\Diff@\Diff@\Hi-Y,@\LSB,@\Lo-Y,@\Hi-X,@\Lo-X@\4014
Diff@\Diff@\Same@\Same@\Hi-Y,@\@\Lo-Y,@\@\Lo-X
Diff@\Diff@\Same@\Diff@\Hi-Y,@\LSB,@\Lo-Y,@\@\Lo-X@\4014
Diff@\Diff@\Diff@\Same@\Hi-y,@\@\Lo-Y,@\Hi-X,@\Lo-X
Diff@\Diff@\Diff@\Diff@\Hi-y,@\LSB,@\Lo-Y,@\Hi-X,@\Lo-X@\4014
@end<format>
@begin<format>
@tabclear()
@tabset(3.0inch,3.6inch,4.1inch,4.7inch,5.3inch,5.95inch)
Kind code for byte:@\20h@\60h@\60h@\20h@\40h
@\(transmitted left to right)
@end<format>
@caption<Tektronix Coordinate Interpretation>
@bar()
@end(table)

Note that LO-Y must be sent if HI-X has changed so that the Tektronix knows theXHI-X byte (in the range of 20h-3Fh) is HI-X and not HI-Y.  LO-Y must also be
sent if LSBXY has changed, so that the 4010 will ignore LSBXY and accept LO-Y.
The LSBXY byte is
@MD<60h + (MARGIN * 10h) + (LSBY * 4) + LSBX>
MARGIN is 0 here and refers to splitting the screen left and right for text
rollover, which the Kermit Tek emulator does not do.

@subu<Tek 4010 Example>:

Suppose <@i(xy)> is point y = 300, x = 500 in Tektronix coordinates.  Split
each 10-bit coordinate into 5-bit groups, add add the Kind code to each. Send
the X part last.
@begin<example>
                HI-Y     LO-Y                   HI-X     LO-X
Y=300d=012Ch=  01001    01100   X=500d=01F4h=  01111    10100
  +Kind code +@u<100000> +@u<1100000>     +kind code +@u<100000> +@u<1000000>
Binary        101001 01101100                 101111  1000100
ASCII            )       l                       /       D
@end<example>
So <@i(xy)> = (500,300) is sent or received in a GS command as @qq<)l/D>.  An
example in C (program fragments):
@begin<example,leftmargin 0,group,blanklines hinge>
#define ESC  27
#define GS   29
#define US   31
FILE *fp;                      /* File descriptor for terminal */
 . . .

    fputc( GS, fp); coord( 75, 65);       /* Move to 75,65      */
    fputc( ESC, fp); fputs("[31m", fp);   /* Set foreground to red */
    fputc( US, fp); fputs("A House", fp); /* Annotate at 75,65  */
    fputc( ESC, fp); fputs("[33m", fp);   /* Set foreground to yellow */
    fputc( GS, fp);                       /* Now draw lines...  */
    coord( 50, 50); coord(300, 50);       /* Bottom side        */
    coord(300,200); coord( 50,200);       /* Right wall, top    */
    coord(175,250); coord(300,200);       /* Roof               */
    fputc( GS, fp);                       /* Start a new line   */
    coord( 50, 50); coord( 50,200);       /* Left wall at 50,50 */
    fputc( ESC, fp); fputs("[37m", fp);   /* Set foreground to white */
    . . .

coord(x, y) int x, y; {        /* Send x,y coordinates to Tek 4010 */
    fputc((y / 32) + 32, fp);             /* High y */
    fputc((y % 32) + 96, fp);             /* Low  y */
    fputc((x / 32) + 32, fp);             /* High x */
    fputc((x % 32) + 64, fp);             /* Low  x */
}
@end<example>

